﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using Sinan.Util;

namespace FilterTest
{
    class Program
    {
        static string text = "名字加fuck日本人妖";
        static HashFilter hf = new HashFilter();
        static TrieFilter tf = new TrieFilter();
        static FastFilter ff = new FastFilter();

        static BadWordsFilter bf1 = new BadWordsFilter();
        static BadWordsFilter2 bf2 = new BadWordsFilter2();
        static BadWordsFilter3 bf3 = new BadWordsFilter3();

        //从文件读取关键字.
        static void ReadBadWord()
        {
            using (StreamReader sw = new StreamReader(File.OpenRead("BadWord.txt")))
            {
                Random random = new Random();
                string key = sw.ReadLine();
                while (key != null)
                {
                    if (key != string.Empty)
                    {
                        hf.AddKey(key);
                        tf.AddKey(key);

                        ff.AddKey(key);

                        bf1.AddKey(key);
                        bf2.AddKey(key);
                        bf3.AddKey(key);
                    }
                    key = sw.ReadLine();
                }
            }
        }

        static void TestHash()
        {
            for (int i = 0; i < 10000; i++)
            {
                hf.HasBadWord(text);
            }
        }

        static void TestTrie()
        {
            for (int i = 0; i < 10000; i++)
            {
                tf.HasBadWord(text);
            }
        }

        static void TestFast()
        {
            for (int i = 0; i < 10000; i++)
            {
                ff.HasBadWord(text);
            }
        }

        static void TestHasBadWord1()
        {
            for (int i = 0; i < 10000; i++)
            {
                bf1.HasBadWord(text);
            }
        }

        static void TestHasBadWord2()
        {
            for (int i = 0; i < 10000; i++)
            {
                bf2.HasBadWord(text);
            }
        }

        static void TestHasBadWord3()
        {
            for (int i = 0; i < 10000; i++)
            {
                bf3.HasBadWord(text);
            }
        }

        static void Main(string[] args)
        {
            ReadBadWord();
            CodeTimer.Initialize();
            using (StreamReader sw = new StreamReader(File.OpenRead("Talk.txt")))
            {
                string key = sw.ReadLine();
                while (key != null)
                {
                    if (key != string.Empty)
                    {
                        Console.WriteLine("-------------开始测试-------------");
                        Console.WriteLine(key);
                        text = key;

                        bool b1 = hf.HasBadWord(text);
                        bool b2 = tf.HasBadWord(text);
                        bool b3 = ff.HasBadWord(text);

                        bool b5 = bf1.HasBadWord(text);
                        bool b6 = bf2.HasBadWord(text);
                        bool b7 = bf3.HasBadWord(text);
                        if (b1 != b2 || b2 != b3 || b3 != b5 || b5 != b6 || b6 != b7)
                        {
                            Console.WriteLine("有算法错误");
                        }

                        CodeTimer.Time("原始", 50, TestHasBadWord1);
                        CodeTimer.Time("优化算法", 50, TestHasBadWord2);
                        CodeTimer.Time("优化hash和BitArray", 50, TestHasBadWord3);

                        CodeTimer.Time("Trie", 50, TestTrie);
                        CodeTimer.Time("Fast", 50, TestFast);

                        Console.WriteLine("推荐使用FastFilter或TrieFilter");
                        //TrieFilter在处理大小写敏感 和 简繁体转换 方面有优势,还有去掉干扰字符也比较方面.
                    }
                    key = sw.ReadLine();
                }
            }
            Console.ReadKey();
        }
    }

}
